﻿using Syncfusion.HtmlConverter;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace HTMLtoPDF_Mvc.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult HtmltoPDF()
        {
            byte[] data = ConvertToPDF();

            Response.AddHeader("content-disposition", "attachment;filename=Questionnaire.pdf");
            return File(data, "application/pdf");
        }

        private byte[] ConvertToPDF()
        {
            string HTMLString = "<!DOCTYPE html><html lang=\"en\" xmlns=\"http://www.w3.org/1999/xhtml\"><body>Hello world</body></html>";
            HtmlToPdfConverter htmlConverter = new HtmlToPdfConverter(HtmlRenderingEngine.WebKit);
            WebKitConverterSettings settings = new WebKitConverterSettings();
            PdfMargins margins = new PdfMargins();
            margins.All = 50;
            settings.Margin = margins;
            settings.WebKitPath = Server.MapPath("/QtBinaries/");
            htmlConverter.ConverterSettings = settings;


            PdfDocument pdfDoc = htmlConverter.Convert(HTMLString, "");
            
            MemoryStream stream = new MemoryStream();

            //Save and checked the output PDF is corrupted or not
            string outputPath = Server.MapPath("/Content/") +  "OutputPdf.pdf";
            pdfDoc.Save(outputPath);

            pdfDoc.Save(stream);
            return stream.ToArray();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}